require 'pstore'

module FuckBot
  class Store
    STATS_RESPONSE = '<@%s>: %s'.freeze

    attr_accessor :data

    def initialize(path)
      path ||= File.join(Dir.home, '.fuck_bot.pstore')
      @ref = PStore.new(path)

      load_data
    end

    def save
      @ref.transaction do
        @ref[:data] = @data
        @ref.commit
      end

      self
    end

    def increment(user_id)
      @data[user_id] += 1

      self
    end

    def to_stats
      @data.sort_by { |_, v| -v }.map do |user, count|
        format(STATS_RESPONSE, user, count)
      end.join("\n")
    end

    private

      def load_data
        @data = @ref.transaction { @ref[:data] } || Hash.new(0)
      end
  end
end
